Index: palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90
===================================================================
--- palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/synthetic_turbulence_generator_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4481 2020-03-31 18:55:54Z maronga
 ! bugfix: cpp-directives for serial mode added, dummy statements to prevent compile errors added
 ! 
@@ -200,4 +203,5 @@
                random_generator,                                               &
                rans_mode,                                                      &
+               restart_data_format_output,                                     &
                restart_string,                                                 &
                syn_turb_gen,                                                   &
@@ -257,4 +261,8 @@
                random_number_parallel,                                         &
                random_seed_parallel
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rrd_mpi_io,                                                                         &
+               wrd_mpi_io
 
     USE transpose_indices,                                                     &
@@ -437,5 +445,6 @@
 !-- Reading of parameters for restart runs
     INTERFACE stg_rrd_global
-       MODULE PROCEDURE stg_rrd_global
+       MODULE PROCEDURE stg_rrd_global_ftn
+       MODULE PROCEDURE stg_rrd_global_mpi
     END INTERFACE stg_rrd_global
 
@@ -1198,7 +1207,7 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data.
-!------------------------------------------------------------------------------!
- SUBROUTINE stg_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE stg_rrd_global_ftn( found )
 
     LOGICAL, INTENT(OUT)  ::  found !< flag indicating if variable was found
@@ -1225,5 +1234,19 @@
 
 
- END SUBROUTINE stg_rrd_global
+ END SUBROUTINE stg_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE stg_rrd_global_mpi
+
+    CALL rrd_mpi_io( 'time_stg_adjust', time_stg_adjust )
+    CALL rrd_mpi_io( 'time_stg_call', time_stg_call )
+    CALL rrd_mpi_io( 'use_syn_turb_gen', use_syn_turb_gen )
+
+ END SUBROUTINE stg_rrd_global_mpi
 
 
@@ -1235,13 +1258,22 @@
  SUBROUTINE stg_wrd_global
 
-    CALL wrd_write_string( 'time_stg_adjust' )
-    WRITE ( 14 )  time_stg_adjust
-    
-    CALL wrd_write_string( 'time_stg_call' )
-    WRITE ( 14 )  time_stg_call
-
-    CALL wrd_write_string( 'use_syn_turb_gen' )
-    WRITE ( 14 )  use_syn_turb_gen
-
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+      CALL wrd_write_string( 'time_stg_adjust' )
+       WRITE ( 14 )  time_stg_adjust
+    
+       CALL wrd_write_string( 'time_stg_call' )
+       WRITE ( 14 )  time_stg_call
+
+       CALL wrd_write_string( 'use_syn_turb_gen' )
+       WRITE ( 14 )  use_syn_turb_gen
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+       CALL wrd_mpi_io( 'time_stg_adjust', time_stg_adjust )
+       CALL wrd_mpi_io( 'time_stg_call', time_stg_call )
+       CALL wrd_mpi_io( 'use_syn_turb_gen', use_syn_turb_gen )
+
+    ENDIF
 
  END SUBROUTINE stg_wrd_global
Index: palm/trunk/SOURCE/turbulence_closure_mod.f90
===================================================================
--- palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/turbulence_closure_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! workaround for Intel14 compiler added
+! 
+! 4486 2020-04-02 20:45:12Z maronga
 ! Bugfix: include topography in calculation of distance_to_wall (1.5-order-dai
 ! closure)
@@ -4903,11 +4906,19 @@
 !--             reason for this behaviour is unknown, however).
                 dvar_dz = atmos_ocean_sign * ( var(k+1,j,i) - var(k-1,j,i) ) * dd2zu(k)
-                IF ( dvar_dz > 0.0_wp ) THEN
+                IF ( dvar_dz > 0.0_wp )  THEN
                    IF ( use_single_reference_value )  THEN
                       ml_stratification(k) = 0.76_wp * SQRT( e(k,j,i) )         &
+#if defined( __imuk_old )
+                             / SQRT( g / var_reference * ( ABS( dvar_dz ) + 1.0E-10_wp ) ) + 1E-5_wp ! required for intel14
+#else
                                   / SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
+#endif
                    ELSE
                       ml_stratification(k) = 0.76_wp * SQRT( e(k,j,i) )         &
+#if defined( __imuk_old )
+                             / SQRT( g / var(k,j,i)    * ( ABS( dvar_dz ) + 1.0E-10_wp ) ) + 1E-5_wp ! required for intel14
+#else
                                   / SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
+#endif
                    ENDIF
                 ELSE
@@ -4961,8 +4972,16 @@
                    IF ( use_single_reference_value )  THEN
                       ml_stratification(k) = 0.76_wp * SQRT( e(k,j,i) )                           &
-                                             / SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
+#if defined( __imuk_old )
+                             / SQRT( g / var_reference * ( ABS( dvar_dz ) + 1.0E-10_wp ) ) + 1E-5_wp ! required for intel14
+#else
+                                  / SQRT( g / var_reference * dvar_dz ) + 1E-5_wp
+#endif
                    ELSE
                       ml_stratification(k) = 0.76_wp * SQRT( e(k,j,i) )                           &
-                                             / SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
+#if defined( __imuk_old )
+                             / SQRT( g / var(k,j,i)    * ( ABS( dvar_dz ) + 1.0E-10_wp ) ) + 1E-5_wp ! required for intel14
+#else
+                                  / SQRT( g / var(k,j,i) * dvar_dz ) + 1E-5_wp
+#endif
                    ENDIF
 
Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 4495)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4493 2020-04-10 09:49:43Z pavelkrc
 ! J.Resler, 2020/03/19
 ! - remove reading of deprecated input parameters c_surface and lambda_surf
@@ -252,5 +255,5 @@
                pt_surface, large_scale_forcing, lsf_surf,                      &
                spinup_pt_mean, spinup_time, time_do3d, dt_do3d,                &
-               average_count_3d, varnamelength, urban_surface, dz
+               average_count_3d, varnamelength, urban_surface, dz, restart_data_format_output
 
     USE bulk_cloud_model_mod,                                                  &
@@ -282,4 +285,7 @@
                iwest_u, iup_l, inorth_l, isouth_l, ieast_l, iwest_l, id,       &
                nz_urban_b, nz_urban_t, unscheduled_radiation_calls
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rd_mpi_io_surface_filetypes, wrd_mpi_io, wrd_mpi_io_surface
 
     USE statistics,                                                            &
@@ -8909,111 +8915,190 @@
 !> Subroutine writes t_surf and t_wall data into restart files
 !------------------------------------------------------------------------------!
-     SUBROUTINE usm_wrd_local
+    SUBROUTINE usm_wrd_local
  
      
-        IMPLICIT NONE
+       IMPLICIT NONE
         
-        CHARACTER(LEN=1) ::  dum     !< dummy string to create output-variable name  
-        INTEGER(iwp)     ::  l       !< index surface type orientation
+       CHARACTER(LEN=1) ::  dum     !< dummy string to create output-variable name
+
+       INTEGER(iwp)     ::  l       !< index surface type orientation
+
+       INTEGER(iwp),DIMENSION(nys:nyn,nxl:nxr) ::  global_start_index  !< index for surface data (MPI-IO)
+
+       LOGICAL ::  surface_data_to_write  !< switch for MPI-I/O if PE has surface data to write
  
-        CALL wrd_write_string( 'ns_h_on_file_usm' )
-        WRITE ( 14 )  surf_usm_h%ns
+
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          CALL wrd_write_string( 'ns_h_on_file_usm' )
+          WRITE ( 14 )  surf_usm_h%ns
+
+          CALL wrd_write_string( 'ns_v_on_file_usm' )
+          WRITE ( 14 )  surf_usm_v(0:3)%ns
+
+          CALL wrd_write_string( 'usm_start_index_h' )
+          WRITE ( 14 )  surf_usm_h%start_index
+
+          CALL wrd_write_string( 'usm_end_index_h' )
+          WRITE ( 14 )  surf_usm_h%end_index
+
+          CALL wrd_write_string( 't_surf_wall_h' )
+          WRITE ( 14 )  t_surf_wall_h
+
+          CALL wrd_write_string( 't_surf_window_h' )
+          WRITE ( 14 )  t_surf_window_h
+
+          CALL wrd_write_string( 't_surf_green_h' )
+          WRITE ( 14 )  t_surf_green_h
+
+          CALL wrd_write_string( 'm_liq_usm_h' )
+          WRITE ( 14 )  m_liq_usm_h%var_usm_1d
+!
+!--       Write restart data which is especially needed for the urban-surface
+!--       model. In order to do not fill up the restart routines in surface_mod.
+!--       Output of waste heat from indoor model. Restart data is required in
+!--       this special case, because the indoor model where waste heat is
+!--       computed is call each hour (current default), so that waste heat would
+!--       have zero value until next call of indoor model.
+          IF ( indoor_model )  THEN
+             CALL wrd_write_string( 'waste_heat_h' )
+             WRITE ( 14 )  surf_usm_h%waste_heat
+          ENDIF
+           
+          DO  l = 0, 3
  
-        CALL wrd_write_string( 'ns_v_on_file_usm' )
-        WRITE ( 14 )  surf_usm_v(0:3)%ns
+             CALL wrd_write_string( 'usm_start_index_v' )
+             WRITE ( 14 )  surf_usm_v(l)%start_index
+
+             CALL wrd_write_string( 'usm_end_index_v' )
+             WRITE ( 14 )  surf_usm_v(l)%end_index
+
+             WRITE( dum, '(I1)')  l
+
+             CALL wrd_write_string( 't_surf_wall_v(' // dum // ')' )
+             WRITE ( 14 )  t_surf_wall_v(l)%t
+
+             CALL wrd_write_string( 't_surf_window_v(' // dum // ')' )
+             WRITE ( 14 ) t_surf_window_v(l)%t
+
+             CALL wrd_write_string( 't_surf_green_v(' // dum // ')' )
+             WRITE ( 14 ) t_surf_green_v(l)%t
+
+             IF ( indoor_model )  THEN
+                CALL wrd_write_string( 'waste_heat_v(' // dum // ')' )
+                WRITE ( 14 )  surf_usm_v(l)%waste_heat
+             ENDIF
+
+          ENDDO
  
-        CALL wrd_write_string( 'usm_start_index_h' )
-        WRITE ( 14 )  surf_usm_h%start_index
- 
-        CALL wrd_write_string( 'usm_end_index_h' )
-        WRITE ( 14 )  surf_usm_h%end_index
- 
-        CALL wrd_write_string( 't_surf_wall_h' )
-        WRITE ( 14 )  t_surf_wall_h
- 
-        CALL wrd_write_string( 't_surf_window_h' )
-        WRITE ( 14 )  t_surf_window_h
- 
-        CALL wrd_write_string( 't_surf_green_h' )
-        WRITE ( 14 )  t_surf_green_h
-
-        CALL wrd_write_string( 'm_liq_usm_h' )
-        WRITE ( 14 )  m_liq_usm_h%var_usm_1d
-!
-!--     Write restart data which is especially needed for the urban-surface 
-!--     model. In order to do not fill up the restart routines in 
-!--     surface_mod. 
-!--     Output of waste heat from indoor model. Restart data is required in 
-!--     this special case, because the indoor model where waste heat is 
-!--     computed is call each hour (current default), so that waste heat would
-!--     have zero value until next call of indoor model. 
-        IF ( indoor_model )  THEN
-           CALL wrd_write_string( 'waste_heat_h' )
-           WRITE ( 14 )  surf_usm_h%waste_heat
-        ENDIF   
-           
-        DO  l = 0, 3
- 
-           CALL wrd_write_string( 'usm_start_index_v' )
-           WRITE ( 14 )  surf_usm_v(l)%start_index
- 
-           CALL wrd_write_string( 'usm_end_index_v' )
-           WRITE ( 14 )  surf_usm_v(l)%end_index
- 
-           WRITE( dum, '(I1)')  l          
- 
-           CALL wrd_write_string( 't_surf_wall_v(' // dum // ')' )
-           WRITE ( 14 )  t_surf_wall_v(l)%t
- 
-           CALL wrd_write_string( 't_surf_window_v(' // dum // ')' )
-           WRITE ( 14 ) t_surf_window_v(l)%t     
- 
-           CALL wrd_write_string( 't_surf_green_v(' // dum // ')' )
-           WRITE ( 14 ) t_surf_green_v(l)%t  
-           
-           IF ( indoor_model )  THEN
-              CALL wrd_write_string( 'waste_heat_v(' // dum // ')' )
-              WRITE ( 14 )  surf_usm_v(l)%waste_heat
-           ENDIF
-           
-        ENDDO
- 
-        CALL wrd_write_string( 'usm_start_index_h' )
-        WRITE ( 14 )  surf_usm_h%start_index
- 
-        CALL wrd_write_string( 'usm_end_index_h' )
-        WRITE ( 14 )  surf_usm_h%end_index
- 
-        CALL wrd_write_string( 't_wall_h' )
-        WRITE ( 14 )  t_wall_h
- 
-        CALL wrd_write_string( 't_window_h' )
-        WRITE ( 14 )  t_window_h
- 
-        CALL wrd_write_string( 't_green_h' )
-        WRITE ( 14 )  t_green_h
- 
-        DO  l = 0, 3
- 
-           CALL wrd_write_string( 'usm_start_index_v' )
-           WRITE ( 14 )  surf_usm_v(l)%start_index
- 
-           CALL wrd_write_string( 'usm_end_index_v' )
-           WRITE ( 14 )  surf_usm_v(l)%end_index
- 
-           WRITE( dum, '(I1)')  l     
- 
-           CALL wrd_write_string( 't_wall_v(' // dum // ')' )
-           WRITE ( 14 )  t_wall_v(l)%t
- 
-           CALL wrd_write_string( 't_window_v(' // dum // ')' )
-           WRITE ( 14 )  t_window_v(l)%t
- 
-           CALL wrd_write_string( 't_green_v(' // dum // ')' )
-           WRITE ( 14 )  t_green_v(l)%t
-        
-        ENDDO
-        
-     END SUBROUTINE usm_wrd_local
+          CALL wrd_write_string( 'usm_start_index_h' )
+          WRITE ( 14 )  surf_usm_h%start_index
+
+          CALL wrd_write_string( 'usm_end_index_h' )
+          WRITE ( 14 )  surf_usm_h%end_index
+
+          CALL wrd_write_string( 't_wall_h' )
+          WRITE ( 14 )  t_wall_h
+
+          CALL wrd_write_string( 't_window_h' )
+          WRITE ( 14 )  t_window_h
+
+          CALL wrd_write_string( 't_green_h' )
+          WRITE ( 14 )  t_green_h
+
+          DO  l = 0, 3
+
+             CALL wrd_write_string( 'usm_start_index_v' )
+             WRITE ( 14 )  surf_usm_v(l)%start_index
+
+             CALL wrd_write_string( 'usm_end_index_v' )
+             WRITE ( 14 )  surf_usm_v(l)%end_index
+
+             WRITE( dum, '(I1)')  l
+
+             CALL wrd_write_string( 't_wall_v(' // dum // ')' )
+             WRITE ( 14 )  t_wall_v(l)%t
+
+             CALL wrd_write_string( 't_window_v(' // dum // ')' )
+             WRITE ( 14 )  t_window_v(l)%t
+
+             CALL wrd_write_string( 't_green_v(' // dum // ')' )
+             WRITE ( 14 )  t_green_v(l)%t
+
+          ENDDO
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+!
+!--       There is no information about the PE-grid necessary because the restart files consists
+!--       the whole domain. Therefore, ns_h_on_file_usm and ns_v_on_file_usm are not used with
+!--       MPI-IO.
+          CALL rd_mpi_io_surface_filetypes( surf_usm_h%start_index, surf_usm_h%end_index,          &
+                                            surface_data_to_write, global_start_index )
+
+          CALL wrd_mpi_io( 'usm_start_index_h',  surf_usm_h%start_index )
+          CALL wrd_mpi_io( 'usm_end_index_h', surf_usm_h%end_index )
+          CALL wrd_mpi_io( 'usm_global_start_h', global_start_index )
+
+          CALL wrd_mpi_io_surface( 't_surf_wall_h',  t_surf_wall_h )
+          CALL wrd_mpi_io_surface( 't_surf_window_h', t_surf_window_h )
+          CALL wrd_mpi_io_surface( 't_surf_green_h', t_surf_green_h )
+
+          CALL wrd_mpi_io_surface( 'm_liq_usm_h', m_liq_usm_h%var_usm_1d )
+          IF ( indoor_model )  THEN
+             CALL wrd_mpi_io_surface( 'waste_heat_h', surf_usm_h%waste_heat ) ! NEED TO BE CHECKED!!!!!
+          ENDIF
+
+          DO  l = 0, 3
+
+             WRITE( dum, '(I1)')  l
+
+             CALL rd_mpi_io_surface_filetypes( surf_usm_v(l)%start_index, surf_usm_v(l)%end_index, &
+                                               surface_data_to_write, global_start_index )
+
+             CALL wrd_mpi_io( 'usm_start_index_v_' // dum, surf_usm_v(l)%start_index )
+             CALL wrd_mpi_io( 'usm_end_index_v_' // dum, surf_usm_v(l)%end_index )
+             CALL wrd_mpi_io( 'usm_global_start_v_' // dum, global_start_index )
+
+             IF ( .NOT. surface_data_to_write )  CYCLE
+
+             CALL wrd_mpi_io_surface( 't_surf_wall_v(' // dum // ')', t_surf_wall_v(l)%t )
+             CALL wrd_mpi_io_surface( 't_surf_window_v(' // dum // ')', t_surf_window_v(l)%t )
+             CALL wrd_mpi_io_surface( 't_surf_green_v(' // dum // ')', t_surf_green_v(l)%t )
+
+          ENDDO
+
+          CALL rd_mpi_io_surface_filetypes( surf_usm_h%start_index, surf_usm_h%end_index,          &
+                                            surface_data_to_write, global_start_index )
+
+          CALL wrd_mpi_io( 'usm_start_index_h_2',  surf_usm_h%start_index )
+          CALL wrd_mpi_io( 'usm_end_index_h_2', surf_usm_h%end_index )
+          CALL wrd_mpi_io( 'usm_global_start_h_2', global_start_index )
+
+          CALL wrd_mpi_io_surface( 't_wall_h', t_wall_h )
+          CALL wrd_mpi_io_surface( 't_window_h', t_window_h )
+          CALL wrd_mpi_io_surface( 't_green_h', t_green_h )
+
+          DO  l = 0, 3
+
+             WRITE( dum, '(I1)')  l
+
+             CALL rd_mpi_io_surface_filetypes( surf_usm_v(l)%start_index, surf_usm_v(l)%end_index, &
+                                               surface_data_to_write, global_start_index )
+
+             CALL wrd_mpi_io( 'usm_start_index_v_2_' //dum, surf_usm_v(l)%start_index )
+             CALL wrd_mpi_io( 'usm_end_index_v_2_' // dum, surf_usm_v(l)%end_index )
+             CALL wrd_mpi_io( 'usm_global_start_v_2_' // dum, global_start_index )
+
+             IF ( .NOT. surface_data_to_write )  CYCLE
+
+             CALL wrd_mpi_io_surface( 't_wall_v(' // dum // ')', t_wall_v(l)%t )
+             CALL wrd_mpi_io_surface( 't_window_v(' // dum // ')', t_window_v(l)%t )
+             CALL wrd_mpi_io_surface( 't_green_v(' // dum // ')', t_green_v(l)%t )
+
+          ENDDO
+
+       ENDIF
+
+    END SUBROUTINE usm_wrd_local
      
      
Index: palm/trunk/SOURCE/user_module.f90
===================================================================
--- palm/trunk/SOURCE/user_module.f90	(revision 4494)
+++ palm/trunk/SOURCE/user_module.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Introduction of wall_flags_total_0, which currently sets bits based on static
 ! topography information used in wall_flags_static_0
@@ -193,5 +196,6 @@
 
     INTERFACE user_rrd_global
-       MODULE PROCEDURE user_rrd_global
+       MODULE PROCEDURE user_rrd_global_ftn
+       MODULE PROCEDURE user_rrd_global_mpi
     END INTERFACE user_rrd_global
 
@@ -247,5 +251,5 @@
 !-- current revision does not match with previous revisions (e.g. if routines
 !-- have been added/deleted or if parameter lists in subroutines have been changed).
-    user_interface_current_revision = 'r3703'
+    user_interface_current_revision = 'r4495'
 
 !
@@ -1106,7 +1110,7 @@
 ! Description:
 ! ------------
-!> Reading global restart data that has been defined by the user.
-!------------------------------------------------------------------------------!
- SUBROUTINE user_rrd_global( found )
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE user_rrd_global_ftn( found )
 
 
@@ -1129,5 +1133,18 @@
 
 
- END SUBROUTINE user_rrd_global
+ END SUBROUTINE user_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE user_rrd_global_mpi
+
+!    CALL rrd_mpi_io( 'global_parameter', global_parameter )
+    CONTINUE
+
+ END SUBROUTINE user_rrd_global_mpi
 
 
@@ -1204,6 +1221,14 @@
  SUBROUTINE user_wrd_global
 
-!    CALL wrd_write_string( 'global_parameter' )
-!    WRITE ( 14 )  global_parameter
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+!       CALL wrd_write_string( 'global_parameter' )
+!       WRITE ( 14 )  global_parameter
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+!    CALL rrd_mpi_io( 'global_parameter', global_parameter )
+
+    ENDIF
 
  END SUBROUTINE user_wrd_global
@@ -1221,8 +1246,16 @@
 !-- Here the user-defined actions at the end of a job follow.
 !-- Sample for user-defined output:
-!    IF ( ALLOCATED( u2_av ) )  THEN
-!       CALL wrd_write_string( 'u2_av' )
-!       WRITE ( 14 )  u2_av
-!    ENDIF
+    IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+!       IF ( ALLOCATED( u2_av ) )  THEN
+!          CALL wrd_write_string( 'u2_av' )
+!          WRITE ( 14 )  u2_av
+!       ENDIF
+
+    ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+!       IF ( ALLOCATED( u2_av ) )  CALL wrd_mpi_io( 'u2_av', u2_av )
+
+    ENDIF
 
  END SUBROUTINE user_wrd_local
Index: palm/trunk/SOURCE/virtual_flight_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 4494)
+++ palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 4495)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! restart data handling with MPI-IO added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -47,8 +50,13 @@
  MODULE flight_mod
  
-    USE control_parameters,                                                    &
-        ONLY:  debug_output, fl_max, num_leg, num_var_fl, num_var_fl_user, virtual_flight
+    USE control_parameters,                                                                        &
+        ONLY:  debug_output, fl_max, num_leg, num_var_fl, num_var_fl_user,                         &
+               restart_data_format_output, virtual_flight
  
     USE kinds
+
+    USE restart_data_mpi_io_mod,                                                                   &
+        ONLY:  rd_mpi_io_check_array, rrd_mpi_io_global_array, wrd_mpi_io_global_array
+
 
     CHARACTER(LEN=6), DIMENSION(fl_max) ::  leg_mode = 'cyclic'  !< flight mode through the model domain, either 'cyclic' or 'return' 
@@ -117,5 +125,6 @@
     
     INTERFACE flight_rrd_global 
-       MODULE PROCEDURE flight_rrd_global
+       MODULE PROCEDURE flight_rrd_global_ftn
+       MODULE PROCEDURE flight_rrd_global_mpi
     END INTERFACE flight_rrd_global
     
@@ -919,7 +928,7 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data.
-!------------------------------------------------------------------------------!
-    SUBROUTINE flight_rrd_global( found )  
+!> Read module-specific global restart data (Fortran binary format).
+!------------------------------------------------------------------------------!
+    SUBROUTINE flight_rrd_global_ftn( found )
 
 
@@ -964,5 +973,53 @@
 
 
-    END SUBROUTINE flight_rrd_global  
+    END SUBROUTINE flight_rrd_global_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific global restart data (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE flight_rrd_global_mpi
+
+
+       IMPLICIT NONE
+
+       LOGICAL  ::  array_found  !< flag indicating if respective array is found in restart file
+
+
+       CALL rd_mpi_io_check_array( 'u_agl', found = array_found )
+       IF ( array_found)  THEN
+          IF ( .NOT. ALLOCATED( u_agl ) )  ALLOCATE( u_agl(1:num_leg) )
+          CALL rrd_mpi_io_global_array( 'u_agl', u_agl )
+       ENDIF
+       CALL rd_mpi_io_check_array( 'v_agl', found = array_found )
+       IF ( array_found)  THEN
+          IF ( .NOT. ALLOCATED( v_agl ) )  ALLOCATE( v_agl(1:num_leg) )
+          CALL rrd_mpi_io_global_array( 'v_agl', v_agl )
+       ENDIF
+       CALL rd_mpi_io_check_array( 'w_agl', found = array_found )
+       IF ( array_found)  THEN
+          IF ( .NOT. ALLOCATED( w_agl ) )  ALLOCATE( w_agl(1:num_leg) )
+          CALL rrd_mpi_io_global_array( 'w_agl', w_agl )
+       ENDIF
+       CALL rd_mpi_io_check_array( 'x_pos', found = array_found )
+       IF ( array_found)  THEN
+          IF ( .NOT. ALLOCATED( x_pos ) )  ALLOCATE( x_pos(1:num_leg) )
+          CALL rrd_mpi_io_global_array( 'x_pos', x_pos )
+       ENDIF
+       CALL rd_mpi_io_check_array( 'y_pos', found = array_found )
+       IF ( array_found)  THEN
+          IF ( .NOT. ALLOCATED( y_pos ) )  ALLOCATE( y_pos(1:num_leg) )
+          CALL rrd_mpi_io_global_array( 'y_pos', y_pos )
+       ENDIF
+       CALL rd_mpi_io_check_array( 'z_pos', found = array_found )
+       IF ( array_found)  THEN
+          IF ( .NOT. ALLOCATED( z_pos ) )  ALLOCATE( z_pos(1:num_leg) )
+          CALL rrd_mpi_io_global_array( 'z_pos', z_pos )
+       ENDIF
+
+    END SUBROUTINE flight_rrd_global_mpi
+
     
 !------------------------------------------------------------------------------!
@@ -976,23 +1033,36 @@
        IMPLICIT NONE
  
-       CALL wrd_write_string( 'u_agl' )
-       WRITE ( 14 )  u_agl
-
-       CALL wrd_write_string( 'v_agl' )
-
-       WRITE ( 14 )  v_agl
-
-       CALL wrd_write_string( 'w_agl' )
-       WRITE ( 14 )  w_agl
-
-       CALL wrd_write_string( 'x_pos' )
-       WRITE ( 14 )  x_pos
-
-       CALL wrd_write_string( 'y_pos' )
-       WRITE ( 14 )  y_pos
-
-       CALL wrd_write_string( 'z_pos' )
-       WRITE ( 14 )  z_pos
-       
+
+       IF ( TRIM( restart_data_format_output ) == 'fortran_binary' )  THEN
+
+          CALL wrd_write_string( 'u_agl' )
+          WRITE ( 14 )  u_agl
+
+          CALL wrd_write_string( 'v_agl' )
+          WRITE ( 14 )  v_agl
+
+          CALL wrd_write_string( 'w_agl' )
+          WRITE ( 14 )  w_agl
+
+          CALL wrd_write_string( 'x_pos' )
+          WRITE ( 14 )  x_pos
+
+          CALL wrd_write_string( 'y_pos' )
+          WRITE ( 14 )  y_pos
+
+          CALL wrd_write_string( 'z_pos' )
+          WRITE ( 14 )  z_pos
+
+       ELSEIF ( TRIM( restart_data_format_output ) == 'mpi' )  THEN
+
+          CALL wrd_mpi_io_global_array( 'u_agl', u_agl )
+          CALL wrd_mpi_io_global_array( 'v_agl', v_agl )
+          CALL wrd_mpi_io_global_array( 'w_agl', w_agl )
+          CALL wrd_mpi_io_global_array( 'x_pos', x_pos )
+          CALL wrd_mpi_io_global_array( 'y_pos', y_pos )
+          CALL wrd_mpi_io_global_array( 'z_pos', z_pos )
+
+       ENDIF
+
     END SUBROUTINE flight_wrd_global    
     
